	program exthssmag50kp
C Input HSS50f.txt 1996-2010...........................Jan 2020
C Add kp index
C
C....................................................Oct. 2019
C Wp-storm from GEOMAG. coord. GIM-TEC  from 04/2011 - to 09/2019
C Pch,Vsw,Dst,Ae,aa,ap,Wpm
C
C Wp = magn coord. map
C....................................................Jan 2017
C outfile='extpchmag4.txt' for Pchg dmax+5 days
C....................................................Dec 2016
C
C Extract geom. indices for 2011.04-2019.09 at Pch-peaks>100i.u. (Dst_min <= -50 nT, Dst <=-30 nT) 
C                    Include AE,aa,ap,Vp (potocYR.txt),Vn(notocYR.txt) indices extraction
C select EXTREME values for time to=nint(to_Pch):to+5 days
C outfile='exthssmag4.txt'
c
	integer IM(12)
	dimension ikp(0:371)  ! +5 days from next year
     +,pch(371),indkp(0:7) 
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*65 infhss ! text
	+,infaa,infile
C	+,infvn,infpch
	+,outfile,txt
	CHARACTER*2 AYR
	CHARACTER*4 AYEAR,AYEAR_nex
C	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/ 
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C

	infaa='d:/apkp/AA/aakpYEAR' !kp, aa, ap
C?	write(*,*) ' Enter YEAR:'
C?	read(*,*) IYEAR
      infile='exthssmag4n50.txt'
	outfile='exthssmag50kp.txt' !total file for 1996-2019 List t0+5days
C 
   30	format(A65)
C  31	format(39X,I4)
  31	format(1X,3I2,1X,F7.2)
   36 format(1X,I4,A1)
   37 format(20X,24(I4))	 ! AE
  137 format(14X,I2) ! kp
  237 format(6X,8(1X,F5.1))  ! ap(tau)
C   34 format(6X,24(1X,I4))  ! (Vp, Vn) 
   34 format(6X,24(1X,F4.1))  !  Wp
C
       do i=1,371
      pch(i)=0.
	 enddo
      icntot=0
C Cycle on years 1999-2016
C	iyear=2010   !TEMP	  Year_pre
	iyear=1995   !TEMP	  Year_pre
C	iyear=2015	 !Temp
	call blet4(iyear,AYEAR)
c//	outfile(6:9)=AYEAR
		OPEN(16,FILE=OUTFILE,access='APPEND')
	nicmes=0	   ! total Vsw-peak events 2011/03-2018/12
C
C start cycle on year: =====================================
C
C+	do 400 KK=1,52	! 1964-2015
C	do 400 KK=1,9	! 2011-2019
	do 400 KK=1,24	! 1996-2010
C-	kk=1 !Temp
C//	if (kk.gt.1) ndyr0=ndnyr
	iyear=iyear+1
Crem	iyear=2015 !TEMP
	call blet4(iyear,AYEAR)
C
      if (iyear.lt.2019) then
	iyear_nex=iyear+1
	else
	iyear_nex=iyear
	endif
      call blet4(iyear_nex,AYEAR_nex)
	ryear=float(iyear)
	AYR=AYEAR(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
		if(int(ryr/4.)*4.eq.iyr) THEN 
		 im(2)=29
	ndnyr=366
	                          ELSE
	IM(2)=28
	ndnyr=365
	ENDIF
C       !==============================================
	do nn=1,ndnyr+5
	ikp(nn)=0
	enddo
C Reading kp aa & ap file
	infaa(16:19)=AYEAR
	OPEN(10,FILE=infaa,action='READ')
	do idd=1,ndnyr
	ikpmax=0
	do ii=0,7
	read(10,137,end=139) indkp(ii)
	if (ikpmax.lt.indkp(ii)) ikpmax=indkp(ii) 
	enddo
	ikp(idd)=ikpmax
	enddo
  139	close(unit=10)
C
C+ 5 days from next year
	infaa(16:19)=AYEAR_nex
	OPEN(10,FILE=infaa,action='READ')
	do idd=ndnyr+1,ndnyr+5
	ikpmax=0
	do ii=0,7
	read(10,137,end=1139) indkp(ii)
	if (ikpmax.lt.indkp(ii)) ikpmax=indkp(ii) 
	enddo
	ikp(idd)=ikpmax
	enddo
 1139	close(unit=10)
C
C
Crem   35 format(1X,F8.3,2(1X,I2),3(1X,F7.2),1X,I4)
   35 format(1X,F8.3,2(1X,I2),A65)
C
C+
C-       	infpch='delpchthr.res' ! All Del >Thr except day-by-day
C==       infsw='HSS50f.txt'       
       infile='exthssmag4n50.txt'       
C
C	OPEN(15,file=infpch,action='READ')
	OPEN(15,file=infile,action='READ')
	read(15,*) txt ! extra line
C
C Cycle on HSS peak events
C
	iev=0
C
Crem	do 28 jj=1,349           ! Catalogue Pch peaks for 2011-2019
	do 28 jj=1,1618        ! Catalogue HSS peaks for 1996-2010
  228 read(15,35,end=27,err=27) ryear,kmn,kdy,infhss
      kyear=int(ryear)
	iev=iev+1
C
C Remove -2018.04.15 
C-	if (kev.ge.281) kev=kev-1
	if (kyear.ne.iyear) GOTO 28
C
	kyr=kyear-(kyear/100)*100
	klda=ndoy(kyr,kmn,kdy)
	klda2=klda+5
	goto 277 ! no Pch data
C
C Select peak indices during from currend day of PCH-max +5 days
C
C+	nxxmax ! peak daily index XX for d0+5 days
C+	nxxday !  nday of delay of XX from d0 to d0+5 days: (nday=0,1,...5)
C
C Select peak Pch
	npcday=0
	pcmax=0.
	do lda=klda,klda2
	if (pch(lda).gt.pcmax) then
	pcmax=pch(lda)
C      npcday=lda-klda
      npcday=klda-lda
	endif
	enddo
C
C Select peak kp
  277	nkpday=0
	nkpmax=0
	do lda=klda,klda2
	if (ikp(lda).gt.nkpmax) then
	nkpmax=ikp(lda)
      nkpday=lda-klda
	endif
	enddo
C
C Output results
C
C	write(*,33) ryear,kmn,kdy,hssmin,hssmax,dhss,npcday,pcmax
	write(*,33) ryear,kmn,kdy,infhss,nkpday,nkpmax,iev
	write(16,33) ryear,kmn,kdy,infhss,nkpday,nkpmax,iev
  28	CONTINUE
   27 close(unit=15)
c
C
C   33 format(1X,F8.3,2(1X,I2),3(1X,F7.2),6(1X,I2,1X,I5),1X,I4)
C   33 format(1X,F8.3,2(1X,I2),3(1X,F6.0),1X,I2,1X,F7.2,4(1X,I2,1X,I5)
   33 format(1X,F8.3,2(1X,I2),A65,2(1X,I2),1X,I4)
C
C
C
  400	CONTINUE ! next year
C	
      close(unit=16)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

