C........................................................Dec. 2021
C 381 Dst storms 1996-2021 exclude Dst peak at t0-24 : t0 
C Keep delHSS > 50 km
C at least 2 days between the preceeding storm onset
C........................................................Apr.2021
C Extract Dst-index for -24h<t0< +48h for SC22(8)/SC23(9)/Dst<-259 nT events 
C 
C Select period of 72hrs starting from t0-24h, ending t0+48h; t0 @ SSC
C 
      PROGRAM decod5dstd1
C Input HSSUT.txt 1996-2010...........................Jan 2020
C add: select from -24h < to <+48h for HSS-events
C
C----------------------------------------------------------------
C
	DIMENSION inds(0:71) ! 3h indices for 24h (0r 72h file for 1h indices)
	+,ind24(0:23)
C
	CHARACTER*4 AYEAR
      CHARACTER*128 INFILE,INFHSS
	+,outfilae
C     +,outfildst  !
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
C++
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
	infile='d:/apkp/dst/dstYEAR' !Dst
C
	outfilae='hssdst3d.txt' !total file for 1997-2019 =8 lines x 24 cols superposed epoch
C	outfildst='hssdst3d.txt' ! Exclude cases of Dst peak at t0-24 : t0
C-      OPEN(12,FILE=OUTFILDST)
C
	nout=0
	OPEN(11,FILE=OUTFILAE)
C
C DST 490 storms from 1996 to 2021
C
   28 format(1X,F8.3,3(1X,I2),3(1X,F6.0))
C   29 format(9X,2I2,2(1X,I2),5X,2I2,2(1X,I2),1X,I4,6X,2I2,2(1X,I2))
   29 format(1X,F8.3,1X,I3,3(1X,I2),1X,I4,2(1X,I4),1X,I3,2(1X,I4))
C  	infhss='dststorms1.txt'  ! 490 Dst events from IZMIRAN Catalogue
  	infhss='catdsthss3.txt'  ! 380 HSS/Dst storms
	open(10,file=infhss,action='READ')
C	read(10,*) txt
C
C Cycle on events ====================================================
C
      lda_pre=10
	iyear_pre=1996
C	DO 177 iev=1,490   !
	DO 177 iev=1,380   !
C      read(10,29,end=27) iyr1,imn1,idy1,iut1,iyr2,imn2,idy2,iut2,idst
      read(10,29,end=27) ryear1,lda1,imn1,idy1,iut1,idst,ivmin,idelsw
	+,idt,ivmax,nout
     	iutcnt=0
	do k=0,71
	inds(k)=0
	enddo
C	if (iyr1.gt.90) then
C	iyear1=1900+iyr1
C	               else
C	iyear1=2000+iyr1
C	                endif
       ryear=ryear1
	iyear=int(ryear1)
	iyear1=iyear
	iyr1=iyear-iyear/100*100
C
C	lda1=ndoy(iyr1,imn1,idy1) ! 1d
      lda0=lda1-1 ! -1d
	lda2=lda1+2
C
      if ((iyear_pre.eq.iyear).and.(lda1-lda_pre.lt.2)) then
	iyear_pre=iyear
	lda_pre=lda1
	GOTO 177
	endif
	iyear_pre=iyear
	lda_pre=lda1
	ryear1=float(iyear1)
		if(int(ryear1/4.)*4.eq.iyear1) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF
C	del=1./ndnyr
C	ryear=ryear1+(lda1-1)*del
C
   37 format(20X,24(I4))	 ! Dst
C
	if (lda0.eq.0) then  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C read last day of prec. year:
C
	iyear0=iyear-1
       call blet4(iyear0,AYEAR)
	infile(16:19)=AYEAR
	open(15,file=infile,action='READ')
	ryear0=float(iyear0)
		if(int(ryear0/4.)*4.eq.iyear0) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF
C
	DO 101 k=1,ndnyr
	read(15,37,end=102) (ind24(ii),ii=0,23)
  101	CONTINUE
  102	close(unit=15)
C last day of prec year from iut1 to 23 h:   
       DO ii=iut1,23
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C
C Prec. day from current year:
       call blet4(iyear,AYEAR)
	infile(16:19)=AYEAR
	open(15,file=infile,action='READ')
C
	if (lda0.gt.0) then !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	DO 109 k=1,lda0
	read(15,37,end=103) (ind24(ii),ii=0,23)
  109	CONTINUE
       DO ii=iut1,23
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C 1st day from current year:
	read(15,37,end=103) (ind24(ii),ii=0,23)
C	  1st day :
       DO ii=0,23
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 2nd day from current year:
	read(15,37,end=103) (ind24(ii),ii=0,23)
C	  2nd day :
       DO ii=0,23
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
C 3rd day from current year:
	read(15,37,end=103) (ind24(ii),ii=0,23)
C	  3rd day :
       DO ii=0,23
	if (iutcnt.lt.72) then
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
  103	close(unit=15)
C
C Next year if necessary:
       if (iutcnt.lt.72) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	iyear1=iyear+1
	call blet4(iyear1,AYEAR)
	infile(16:19)=AYEAR
	open(15,file=infile,action='READ')
C
	read(15,37,end=104) (ind24(ii),ii=0,23)
C	  next day :
       DO ii=0,23
	if (iutcnt.lt.72) then
       inds(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
              	else
	exit
              	endif
	ENDDO
  104	close(unit=15)
      endif	                !>>>>>>>>>>>>>>>>>>>>>
C
  138 format(72(1X,I4))
  139	FORMAT(1X,F8.3,1X,I3,3(1X,I2),2(1X,I4))
C Check Dst min at t0-24 : t0 Exclude these results
      mindst=0.
	do k=0,71
	if (inds(k).lt.mindst) then
	k1=k
	mindst=inds(k)
	endif
	enddo
	
	if (k1.lt.23) goto 177  ! avoid output for Dst min at t0-24h : t0
C Output matrices:
      nout=nout+1
      write(*,139) ryear,lda1,imn1,idy1,iut1,idst,nout
C	write(12,139) ryear,lda1,imn1,idy1,iut1,idst,nout
C
 	write(*,138) (inds(k),k=0,71)
	write(11,138) (inds(k),k=0,71)
  177	CONTINUE
   27 close(unit=10)
      close(unit=11)
C
C
   35      write(*,*) infile
      pause ' ' 
      STOP
       END

C***********************************************************
