      program extvsmlat
C..................................................................................Dec. 2018
C Extract daily-hourly occurrence, %, Vsigma index at 9 mlat bins from Vs geogr. maps:
C      mlat < -70
C     (1) mlat -70.0 : -50
C     (2) mlat -50.0 : -30
C     (3) mlat -30.0 : -10
C     (4) mlat -10.0 :  10
C     (5) mlat  10.0 :  30
C     (6) mlat  30.0 :  50
C     (7) mlat  50.0 :  70
C      mlat > 70.0 
C Data : dip.txt (geogr. lats of mdip at geogr. longs -180:5: 180)
      dimension DIP(0:72),glats(9,0:72)
C	,glons(0:72)
        CHARACTER*60 outfile
      data DIP/
     +   2.60,  1.75,  1.05,  0.45, -0.10, -0.61, -1.20, -1.79, -2.40
     +, -3.20, -3.65, -4.27, -4.94, -5.68, -6.50, -7.40, -8.45, -9.55
     +,-10.60,-11.47,-12.10,-12.18,-11.62,-10.37, -8.45, -6.00, -3.01
     +,  0.34,  3.34,  5.89,  7.97,  9.49, 10.50, 11.17, 11.46, 11.57
     +, 11.52, 11.37, 11.19, 10.92, 10.54, 10.05,  9.41,  8.73,  8.07
     +,  7.50,  7.20,  7.05,  7.03,  7.12,  7.29,  7.47,  7.65,  7.84
     +,  7.91,  7.93,  7.87,  7.76,  7.58,  7.47,  7.45,  7.52,  7.58
     +,  7.71,  7.68,  7.51,  7.25,  6.80,  6.20,  5.33,  4.47,  3.50
     +,  2.60/

	COMMON  /CONST/UMR
	cc=','
	outfile='dipglats.txt'
	OPEN(10,file=outfile)
	IYEAR=2015
C
   29 format(1X,F6.2)
   33 format(2(1X,F6.2))
	dmlat=-110.0
	ZLAT=-90.
	DO lats=1,7
	ZLAT=ZLAT+20.
	write(*,29) ZLAT
		write(10,29) ZLAT
	dmlat=dmlat+20.
	glon=-185.0
	do kk=0,72
	glon=glon+5.
	YLATI=DIP(kk)
	YLONGI=glon
	if (glon.lt.0.) YLONGI=glon+360.0
	jmag=0
      CALL GEODIP(IYEAR,YLATI,YLONGI,XMLAT,XMLONG,JMAG) ! produce MLAT,MLON
	XMLAT=DMLAT
	jmag=1
	CALL GEODIP(IYEAR,YLATI,YLONGI,XMLAT,XMLONG,JMAG) ! produce YLATI,YLONGI
	 glats(lats,kk)=YLATI
	write(*,33) ylongi,ylati
	write(10,33) ylongi,ylati
	enddo
	ENDDO
	pause ' '
	STOP
	END

c===============================================================================
