      program histpch
C..............................................................................Oct 2019
C Effective Pch events
C
      dimension hpc(13),ipc(13),hpcm(9),ipcm(9),ihsw(7),isw(7)
	+,ihae(9),iae(9)
	+,ihaa(16),iaa(16),ihap(11),iap(11)
	+,hwp(10),iwp(10),ihds(11),ids(11),per(16)
	CHARACTER*65 infile,outfile,txt
		CHARACTER*4 word
      DATA hpc/100.,150.,200.,250.,300.,350.,400.,450.,500.
	+,550.,600.,650.,700./
	DATA hpcm/200.,300.,400.,500.,600.,700.,800.,900.,1000./
	DATA ihsw/200,300,400,500,600,700,800/
	DATA ihae/200,300,400,500,600,700,800,900,1000/
	DATA ihaa/0,10,20,30,40,50,60,70,80,90,100,120,140,160,180,200/
	DATA ihap/0,10,20,30,40,50,60,70,80,90,100/
	DATA hwp/2.5,3.0,3.5,4.0,4.5,5.0,5.5,6.0,6.5,7.0/
	DATA ihds/0,-10,-20,-30,-40,-50,-60,-70,-80,-90,-100/
C
	infile='extpchcat4.txt'
	OPEN(10,FILE=infile,action='READ')
	read(10,*) txt !extra line
	outfile='histpch.res'
	OPEN(11,FILE=OUTFILE,access='APPEND')
C
   29 format(1X,F8.3,2(1X,I2),3(1X,F7.2),5(1X,I2,1X,I5),1X,I2,1X,F4.1
     +,1X,I4)

C
      do i=1,7
	isw(i)=0
	enddo
      do i=1,9
	ipcm(i)=0
	iae(i)=0
	enddo
      do i=1,10
	iwp(i)=0
	enddo
      do i=1,11
	iap(i)=0
	ids(i)=0
	enddo
      do i=1,13
	ipc(i)=0
	enddo
      do i=1,16
	iaa(i)=0
	enddo
C
	DO 40 ii=1,348
	read(10,29,end=50) ryear,kmn,kdy,pchmin,pchmax,dpch,nswday,nswmax
	+,naeday,naemax,naaday,naamax,napday,napmax,ndsday,ndsmin
	+,nwpday,wpmax,kev
	if (dpch.ge.700.) then
	ipc(13)=ipc(13)+1
	goto 41
	endif
	do i=1,12
	if ((dpch.ge.hpc(i)).and.(dpch.lt.hpc(i+1))) then
	ipc(i)=ipc(i)+1
	exit
	endif
	enddo
   41	continue
	if (nswmax.ge.800) then
	isw(7)=isw(7)+1
	goto 42
	endif
	do i=1,6
	if ((nswmax.ge.ihsw(i)).and.(nswmax.lt.ihsw(i+1))) then
	isw(i)=isw(i)+1
      exit
	endif
	enddo
   42	continue
	if (naemax.ge.1000) then
	iae(9)=iae(9)+1
	goto 43
	endif
	do i=1,8
	if ((naemax.ge.ihae(i)).and.(naemax.lt.ihae(i+1))) then
	iae(i)=iae(i)+1
	exit
	endif
	enddo
   43	continue
	if (naamax.ge.200) then
	iaa(16)=iaa(16)+1
	goto 44
	endif
	do i=1,15
	if ((naamax.ge.ihaa(i)).and.(naamax.lt.ihaa(i+1))) then
	iaa(i)=iaa(i)+1
	exit
	endif
	enddo
   44	continue
	if (napmax.ge.100) then
	iap(11)=iap(11)+1
	goto 45
	endif
	do i=1,10
	if ((napmax.ge.ihap(i)).and.(napmax.lt.ihap(i+1))) then
	iap(i)=iap(i)+1
	exit
	endif
      enddo
   45	continue
	if (wpmax.ge.7.0) then
	iwp(10)=iwp(10)+1
	goto 46
	endif
	do i=1,9
	if ((wpmax.ge.hwp(i)).and.(wpmax.lt.hwp(i+1))) then
	iwp(i)=iwp(i)+1
	exit
	endif
      enddo
   46	continue
	if (ndsmin.le.-100) then
	ids(11)=ids(11)+1
	goto 47
	endif
	do i=1,10
	if ((ndsmin.le.ihds(i)).and.(ndsmin.gt.ihds(i+1))) then
	ids(i)=ids(i)+1
	exit
	endif
      enddo
   47	continue
	if (pchmax.ge.1000.) then
	ipcm(9)=ipcm(9)+1
	goto 49
	endif
	do i=1,8
	if ((pchmax.ge.hpcm(i)).and.(pchmax.lt.hpcm(i+1))) then
	ipcm(i)=ipcm(i)+1
	exit
	endif
	enddo
   49	continue
C
   40	continue ! events cycle
   50 close(unit=10)
C
C Output results
C
        word='pc=['
	do i=1,13
      per(i)=ipc(i)/348.*100.
	enddo
	write(*,60) (hpc(k),k=1,13)
	write(11,60) (hpc(k),k=1,13)
      write(*,30) word,(ipc(k),k=1,13)
      write(11,30) word,(ipc(k),k=1,13)
      write(*,31) word,(per(k),k=1,13)
      write(11,31) word,(per(k),k=1,13)
C
        word='pm=['
	do i=1,9
      per(i)=ipcm(i)/348.*100.
	enddo
	write(*,160) (hpcm(k),k=1,9)
	write(11,160) (hpcm(k),k=1,9)
      write(*,130) word,(ipcm(k),k=1,9)
      write(11,130) word,(ipcm(k),k=1,9)
      write(*,131) word,(per(k),k=1,9)
      write(11,131) word,(per(k),k=1,9)
C
        word='sw=['
	do i=1,7
      per(i)=isw(i)/348.*100.
	enddo
	write(*,61) (ihsw(k),k=1,7)
	write(11,61) (ihsw(k),k=1,7)
      write(*,32) word,(isw(k),k=1,7)
      write(11,32) word,(isw(k),k=1,7)
      write(*,33) word,(per(k),k=1,7)
      write(11,33) word,(per(k),k=1,7)
C
        word='ae=['
	do i=1,9
      per(i)=iae(i)/348.*100.
	enddo
	write(*,65) (ihae(k),k=1,9)
	write(11,65) (ihae(k),k=1,9)
      write(*,30) word,(iae(k),k=1,9)
      write(11,30) word,(iae(k),k=1,9)
      write(*,31) word,(per(k),k=1,9)
      write(11,31) word,(per(k),k=1,9)
C
        word='aa=['
	do i=1,16
      per(i)=iaa(i)/348.*100.
	enddo
	write(*,163) (ihaa(k),k=1,16)
	write(11,163) (ihaa(k),k=1,16)
      write(*,136) word,(iaa(k),k=1,16)
      write(11,136) word,(iaa(k),k=1,16)
      write(*,137) word,(per(k),k=1,16)
      write(11,137) word,(per(k),k=1,16)
C
        word='ap=['
	do i=1,11
      per(i)=iap(i)/348.*100.
	enddo
	write(*,63) (ihap(k),k=1,11)
	write(11,63) (ihap(k),k=1,11)
      write(*,36) word,(iap(k),k=1,11)
      write(11,36) word,(iap(k),k=1,11)
      write(*,37) word,(per(k),k=1,11)
      write(11,37) word,(per(k),k=1,11)
C
        word='wp=['
	do i=1,10
      per(i)=iwp(i)/348.*100.
	enddo
	write(*,64) (hwp(k),k=1,10)
	write(11,64) (hwp(k),k=1,10)
      write(*,38) word,(iwp(k),k=1,10)
      write(11,38) word,(iwp(k),k=1,10)
      write(*,39) word,(per(k),k=1,10)
      write(11,39) word,(per(k),k=1,10)
C
        word='dst:'
	do i=1,11
      per(i)=ids(i)/348.*100.
	enddo
	write(*,63) (ihds(k),k=1,11)
	write(11,63) (ihds(k),k=1,11)
      write(*,36) word,(ids(k),k=1,11)
      write(11,36) word,(ids(k),k=1,11)
      write(*,37) word,(per(k),k=1,11)
      write(11,37) word,(per(k),k=1,11)
   60	FORMAT(1X,'hpc=[',13(1X,F4.0),']')
  160	FORMAT(1X,'hpc=[',9(1X,F4.0),']')
   61	FORMAT(1X,'hsw=[',7(1X,I4),']')
   62	FORMAT(1X,'hae=[',8(1X,I4),']')
   63	FORMAT(1X,'haa=[',11(1X,I4),']')
  163	FORMAT(1X,'haa=[',16(1X,I4),']')
   64	FORMAT(1X,'hwp=[',10(1X,F4.1),']')
   65	FORMAT(1X,'hpc=[',9(1X,I4),']')
   30	FORMAT(1X,A4,13(1X,I4),']')
  130	FORMAT(1X,A4,9(1X,I4),']')
   31 FORMAT(1X,A4,13(1X,F5.2),']')
  131 FORMAT(1X,A4,9(1X,F5.2),']')
   32	FORMAT(1X,A4,7(1X,I3),']')
   33 FORMAT(1X,A4,7(1X,F5.2),']')
   34	FORMAT(1X,A4,8(1X,I3),']')
   35 FORMAT(1X,A4,8(1X,F5.2),']')
   36	FORMAT(1X,A4,11(1X,I3),']')
  136	FORMAT(1X,A4,16(1X,I3),']')
   37 FORMAT(1X,A4,11(1X,F5.2),']')
  137 FORMAT(1X,A4,16(1X,F5.2),']')
   38	FORMAT(1X,A4,10(1X,I3),']')
   39 FORMAT(1X,A4,10(1X,F5.2),']')
      close(unit=11)
      pause ' '
	STOP
	END