C					                                  Apr. 2018
C       Extract TEC(st,mn-med) from monthly median GIM-TEC map
C       Use submedstd1.for for monthly day number.
C
C
      program Extecmnmed
C 
      DIMENSION im(12),ires(0:72),STD(0:72)
	+,CC(31,0:72),SMED(0:72),DAT(31,71,0:72) ! daily GIM-TEC maps
	+glats(47),glons(47)
      character*2 ayr,amn,ady,aut,sts(47)
	character*45 infile,outfile

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA sts/
     + 'at','au','bc','bp','br','cb','ch','cn','cq','db'
     +,'dw','eb','gm','gr','gu','ha','ho','jj','jm','jr'
     +,'kk','lv','mg','ml','mo','nc','nd','ni','ns','ok'
     +,'pe','pq','ps','rm','ro','rv','sd','so','sq','tk'
     +,'tr','tv','tz','wk','wp','wz','yg'/
	DATA glats/
     +  38.4, 30.4, 40.0, 40.0,-27.5,-35.3, 51.6,-34.0, 29.5, 50.1
     +,-12.2, 40.8, 37.6,-33.3, 23.1, 18.3,-42.9, 33.5,-12.0, 54.6
     +, 35.7,-28.5, 60.0, 49.6, 55.5, 35.0, 19.1,-29.0, 54.6, 26.3
     +,-32.0, 50.0,-51.7, 18.5, 41.8, 47.2, 66.5, 67.4,-77.9, 56.5
     +, 69.7,-19.7, 61.6, 45.4, 37.8, 52.2, 29.2/
      DATA glans/
	  23.6,262.3,254.7,116.3,152.9,149.1,358.7,150.7,106.4,  4.6
	+,130.9,  0.5, 14.0, 26.5,113.4,109.3,147.2,126.5,283.1, 13.4
     +,139.5, 21.2,151.0,117.5, 37.3, 33.2,169.9,168.0, 83.2,127.8
     +,115.9, 14.6,302.2,292.8, 12.5, 39.7, 66.5, 26.6,166.8, 84.9
     +, 19.0,146.9, 90.0,141.7,284.5, 21.1,129.6/             
C
c
c       write(*,*) 'ENTER YR:'
c	 read(*,*) AYR
c       write(*,*) 'ENTER MN:'
c	 read(*,*) AMN
C       write(*,*) 'ENTER DY:'
C	 read(*,*) ADY
C
		read(amn,*) rmn
	imn=int(rmn)
c		read(ady,*) rdy
c	idy=int(rdy)
C
		read(ayr,*) yr
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	outfile='d:\web\graf\dtc\yr\mn\tcMN15UT.mYR' !median maps
	outfile(17:18)=ayr
	outfile(20:21)=amn
	outfile(25:26)=amn
	outfile(33:34)=ayr

C++   18	
C
  103 format(1X,A2)

       infile='d:\web\graf\dtc\yr\mn\ut\tcMNDDUT.jYR'
	infile(17:18)=ayr
	infile(20:21)=amn
	infile(28:29)=amn
	infile(36:37)=ayr
C
C
	ndnr=im(imn)
C
C
C   UT cicle

      DO 110 iut=0,23
C
       call blet2(iut,AUT)
      write(*,*) ' UT=',AUT
	infile(32:33)=AUT
	outfile(29:30)=AUT
C
	OPEN(12,FILE=outfile)
C
      DO K=0,72
      SMED(K)=0.0
	STD(K)=0.0
	enddo
C
C Input daily files for given UT:
  107	FORMAT(73(1X,F4.1))
C
C Day-to-day reading maps cycle for given UT:
C
      DO 111 idy=1,ndnr
	call blet2(idy,ADY)
	infile(30:31)=ADY
C
      OPEN(11,FILE=INFILE)
C
    	do 80 ilat=1,71
  	READ (11,107,END=81,ERR=2) (dat(idy,ilat,k),k=0,72)
   80	continue
   81	close(unit=11)
C
  111 CONTINUE	

C Prepare array CC for median calculation
C
C Cycle on lati:
       DO 102 ilat=1,71  !>>>>>>>>>>>>>
C
	DO icc=1,ndnr
	do k=0,72
	CC(icc,k)=dat(icc,ilat,k)
	enddo
	enddo
C
	call submedstd1(ndnr,72)	! xmed for given day/hour UT/Lati
C
	do kk=0,72
	ires(kk)=nint(smed(kk)*10.)
	enddo 
Crem      write(*,98) (ires(k),k=0,72)
  	write(12,98) (ires(k),k=0,72)
  98  format(73(1X,I4))
 102  continue
      close(unit=12)
C
  110	CONTINUE	 ! Cycle on UT
C
       GOTO 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
      write(*,*) infile,outfile
      pause ' ' 
   34   STOP
       END

