	program histecdhc
c .......................................................Apr 2019
C Histogram of occurrence (Hc-hcF2) vs vTEC (45N,15E)	Hc=center-of-mass
C HSA for 2001/07-2002/06
C LSA for 2008/01-2008/12
c
C	DIMENSION TEC(49),dhc(49) !LSA
	DIMENSION TEC(136),dhc(136) !HSA 
	+,dtec(288),del(288)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile,txt
C	DATA TEC/4.0,4.25,4.5,4.75,5.0,5.25,5.5,5.75,6.0,6.25,6.5,6.75     !LSA
C	+,7.0,7.25,7.5,7.75,8.0,8.25,8.5,8.75,9.0,9.25,9.5,9.75			   !LSA
C     +,10.0,10.25,10.5,10.75,11.0,11.25,11.5,11.75,12.0,12.25,12.5,12.75 !LSA
C     +,13.0,13.25,13.5,13.75,14.0,14.25,14.5,14.75,15.0,15.25,15.5,15.75 !LSA
C     +,16.0/ 															   !LSA
C
	DATA TEC/
     + 11.0,11.5,12.0,12.5,13.0,13.5,14.0,14.5,15.0,15.5,16.0,16.5 !HSA
     +,17.0,17.5,18.0,18.5,19.0,19.5,20.0,20.5,21.0,21.5,22.0,22.5 !HSA
     +,23.0,23.5,24.0,24.5,25.0,25.5,26.0,26.5,27.0,27.5,28.0,28.5 !HSA
     +,29.0,29.5,30.0,30.5,31.0,31.5,32.0,32.5,33.0,33.5,34.0,34.5 !HSA
	+,35.0,35.5,36.0,36.5,37.0,37.5,38.0,38.5,39.0,39.5,40.0,40.5 !HSA
	+,41.0,41.5,42.0,42.5,43.0,43.5,44.0,44.5,45.0,45.5,46.0,46.5 !HSA
	+,47.0,47.5,48.0,48.5,49.0,49.5,50.0,50.5,51.0,51.5,52.0,52.5 !HSA
	+,53.0,53.5,54.0,54.5,55.0,55.5,56.0,56.5,57.0,57.5,58.0,58.5 !HSA
	+,59.0,59.5,60.0,60.5,61.0,61.5,62.0,62.5,63.0,63.5,64.0,64.5 !HSA
	+,65.0,65.5,66.0,66.5,67.0,67.5,68.0,68.5,69.0,69.5,70.0,70.5 !HSA
	+,71.0,71.5,72.0,72.5,73.0,73.5,74.0,74.5,75.0,75.5,76.0,76.5 !HSA
	+,77.0,77.5,78.0,78.5/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
		  outfile='histecdhc.res'
	OPEN(11,FILE=OUTFILE,ACCESS='APPEND')
C
   36	format(10X,F5.1,12X,F3.0)

C	infile='thcx450x0950.lsa' !LSA
	infile='thcx450x0950.hsa' !HSA

		OPEN(10,FILE=infile,ACTION='READ')
	read(10,*) txt
	write(11,*) txt
C
 	icntot=0 ! count of del(hc-hmF2)
	do ii=1,288
	read(10,36,end=55) dtec(ii),del(ii)
      icntot=icntot+1
	enddo      
  55  CLOSE(unit=10)
C start
C	do i=1,49		  !LSA
	do i=1,136		  !HSA
	dhc(i)=0.
	enddo
      delmin=1000.
	delmax=0.
	delave=0.
C cycle on events	
	nres=0
	DO 101 ii=1,icntot
	teci=dtec(ii)
	dev=del(ii)
	if (dev.gt.delmax) delmax=dev
	if (dev.lt.delmin) delmin=dev
	delave=delave+dev
c     
C	do j=1,48 !LSA
	do j=1,135 !HSA
	if ((teci.ge.tec(j)).and.(teci.lt.tec(j+1))) then
	dhc(j)=dhc(j)+1.0
	exit
 	endif
	enddo
101	CONTINUE	   
       delave=delave/288.
C STD
       sum=0.
	DO k=1,icntot
	dev=del(k)
	sum=sum+(dev-delave)**2
	ENDDO
	std=sqrt(sum/288.)
C Output
      write(*,790) icntot,delmin,delave,delmax,std
	write(11,790) icntot,delmin,delave,delmax,std
 790  format(2X,I4,4(1X,F7.2))
C	do ii=1,48	 !LSA
	do ii=1,135	 !HSA
	per=dhc(ii)/icntot
	teci=tec(ii)
c-	ires(ii)=int(rsw(ii))
	write(*,791) teci,per
	write(11,791) teci,per
	enddo
 105	CONTINUE
 791  format(2(1X,F6.3))
c   
  800 CONTINUE             
	CLOSE(unit=11)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

