	program histhsskp1d
c .......................................................Dec 2020
C Histogram of occurrence kp(HSS)	1185*72 array of kp*10 @ HSS storms
C for 1996-2019
C
c
	DIMENSION ikp(0:27),icn(0:27),ind(0:71)
c	+,idv(0:3),ivs(0:3),iap(0:3),iaa(0:3)
c	+,iae(0:3),ids(0:3),twp(0:3)
c	+,nkp(0:3),ndv(0:3),nvs(0:3),nap(0:3),naa(0:3)
c 	+,nae(0:3),nds(0:3),nwp(0:3)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile
C-	DATA ikp/0,2,3, 4, 5, 6, 7, 9,12,15,18,22,27,32		           !ap
C     +,39,48,56,67,80,94,111,132,154,179,207,236,300,400/		   !ap
C+	DATA ikp/0,3,7,10,13,17,20,23,27,30,33,37,40,43                ! kp
C+     &, 47,50,53,57,60,63, 67, 70, 73, 77, 80, 83, 87, 90/		   !kp
	DATA ikp/0,5,7,11,12,14,16,18,20,22,27,33,36,38,40,58,62,66,72   !aa
	+,88,100,120,140,166,198,268,354,600/						   !aa
c	+,iap/0,15,48,80/,iaa/0,42,70,108/
c	+,iae/0,450,900,1150/
c	+,ids/0,-20,-45,-75/,twp/0.0,3.5,5.3,6.3/,idv/0,55,95,135/
c     +,ivs/100,400,550,630/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
		  outfile='histhss1d.res'
	OPEN(11,FILE=OUTFILE,ACCESS='APPEND')
C
   36	format(72(1X,I3))

C
C	infile='hsskp1d.txt'				! kp
C-	infile='hssap1d.txt'				! ap
	infile='hssaa1d.txt'				! ap
		OPEN(10,FILE=infile,ACTION='READ')
	write(*,*) infile
	write(11,*) infile

C	read(10,*) txt ! title line
C
 	icntot=0 ! count of dPch
	do kk=0,27
	icn(kk)=0
	enddo
C
       iswmin=1000.
	iswmax=0.
	DO 51 iev=1,455
   1	read(10,36,end=155) (ind(k),k=0,71)
      icntot=icntot+72
C
      DO kk=0,71
	kp=ind(kk)
	do ii=1,27
	if (ind(ii).lt.iswmin) iswmin=ind(ii)
      if (ind(ii).gt.iswmax) iswmax=ind(ii)
	if (kp.eq.ikp(27)) then
	 icn(27)=icn(27)+1
	endif
	if ((kp.ge.ikp(ii-1)).and.(kp.lt.ikp(ii))) then 
	 icn(ii-1)=icn(ii-1)+1
	endif
	enddo
	ENDDO
   51	CONTINUE      
C
 155  CLOSE(unit=10)
	cntot=float(icntot)
       write(*,*)icntot,iswmin,iswmax
	sum=0
C kp
      do ii=0,27
	per=float(icn(ii))/cntot*100. !%
	sum=sum+per
C kp
	write(*,790) ikp(ii),icn(ii),per
	write(11,790) ikp(ii),icn(ii),per
	enddo
 790  format(1X,I4,1X,I6,1X,F6.2)
C  %
c   
	CLOSE(unit=11)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

