C........................................................Apr 2023
C
C Extract Dst  for -12h<t0(Dstmin)< +36h for 236 Apo > 100 nT events 1995-2023
C
C........................................................Mar. 2023
C 
C t0 at Apo >=100nT storm peak
C
C Extract dGEC  for -12h<t0< +36h for Apo events (t0 at Apo > 100 nT)
C 
C Select period of 48hrs starting from t0-12h, ending t0+35h; 
C 
      PROGRAM decodt0dst12
C Input HSSUT.txt 1995-2023...........................Jan 2020
C
C----------------------------------------------------------------
C
	DIMENSION inpn(0:71) ! 1h indices for 24h (or 72h file for 1h indices)
	+,ind24(0:23),inpn_pre(0:71),IM(12)
C
	CHARACTER*4 AYEAR
      CHARACTER*128 INFILE,INFHSS
	+,outfile  !
	 CHARACTER*20 dstread
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
      CHARACTER*2 AYR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
      infile='d:/Apkp/dst/dstYEAR'
C      infile='d:/web/dat0/YR/dgecYEAR.txt'
C
	outfile='dstt0d12.txt' !Dst(t0 at Dstmin) total file for 1995-2023 Apo-storms =nev lines x 48 cols superposed epoch	! 3
C//  	infhss='kpstormx.txt'  ! Kp storms 1 or 2
  	infhss='catapodst.txt'  ! Dst storms t0(Dstmin) for Apo storms Apo>=100 nT
Ctemp  	infhss='catdst0apo.txt'  ! Dst storms t0(Dstmin) for Apo storms Apo>=100 nT
C
C Start 
C
    1	CONTINUE
C
    7	OPEN(11,FILE=OUTFILE)
C    7	OPEN(11,FILE=OUTFILE,access='APPEND') !Temp
C
C Kp_1_2 nev storms from 1994 to 2021
C
   28 format(1X,F8.3,3(1X,I2),3(1X,F6.0))
   29 format(A20,1X,I4,3(1X,I2),1X,F5.0)
  129 format(1X,F8.3,2(1X,I3,3(1X,I2),1X,F5.0))
  197 format(3X,2A2,1X,A2,10X,24(1X,I4))
C
	open(10,file=infhss,action='READ')
C	read(10,*) txt
C
C
C Cycle on events ====================================================
C
Cnorm	nev=945 1995- 2023.02
C-       	nev=932	 !TEmp
C-       	nev=70 ! intense Spo smoothed storms
       	nev=236 ! intense Apo storms	
C
	DO 177 iev=1,nev
      read(10,*,end=27) ryear,ldap,imnp,idyp,iutp,aep,lda1,imn1,idy1
	+,iut1,dst,idt,nn
	 iyear=int(ryear)
C
	iutcnt=0
	iyr=iyear-iyear/100*100
	iut0=iut1-12
	idy0=idy1
	imn0=imn1
	iyear0=iyear
	if (iut0.lt.0) then
	iut0=iut0+24
	idy0=idy1-1
	if(idy0.eq.0) then
	imn0=imn1-1
	idy0=IM(imn0)
	if (imn0.eq.0) then
	imn0=12
      idy0=31
	iyear0=iyear-1
	endif
         endif
	         endif	
	iyr0=iyear0-iyear0/100*100
C
C
	lda1=ndoy(iyr,imn1,idy1) ! 1d
      lda0=ndoy(iyr0,imn0,idy0) ! 1d
C-      lda0=lda1-1 ! -1d
	lda2=lda1+2
	ryear=float(iyear)
		if(int(ryear/4.)*4.eq.iyear) THEN 
	ndnyr=366
	IM(2)=29
	                          ELSE
	ndnyr=365
	IM(2)=28
	ENDIF
	if (lda2.gt.ndnyr) lda2=lda2-ndnyr
C
   37 format(A20,24(I4))	 ! dst
C-   37	format(A4,2(1X,A2),44X,I3)
C-   37	format(3(A2),24(1X,I4))	  !dGEC
C
Cpre	if (lda0.eq.0) then  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	if (lda0.gt.364) then  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C read last day of prec. year:
C
	iyear0=iyear-1
       call blet4(iyear0,AYEAR)
	AYR=AYEAR(3:4)
C	infile(13:14)=AYR
		infile(16:19)=AYEAR  ! 
C
	open(15,file=infile,action='READ')
	ryear0=float(iyear0)
		if(int(ryear0/4.)*4.eq.iyear0) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF

	DO 101 k=1,ndnyr
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=102) DYR,DMN,DDY,(ind24(ii),ii=0,23) ! dGEC
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
  101	CONTINUE
  102	close(unit=15)
C last day of prec year from iut1 to 23 h:   
Cpre       DO ii=iut1,23
       DO ii=iut0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C
C Prec. day from current year:
       call blet4(iyear,AYEAR)
	AYR=AYEAR(3:4)
C-	infile(13:14)=AYR
		infile(16:19)=AYEAR  ! 
	open(15,file=infile,action='READ')
C
Cpre	if (lda0.gt.0) then !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	if (lda0.eq.lda1-1) then !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	DO 109 k=1,lda0
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=103) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
  109	CONTINUE
Cpre       DO ii=iut1,23
       DO ii=iut0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	endif				 !>>>>>>>>>>>>>>>>>>>>>>>>
C 1st day from current year:
        if (iutcnt.eq.0) THEN   !
	DO ldy=1,lda0
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=103) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-       enddo
	 enddo
C	  1st day :
Cpre       DO ii=0,23
         DO ii=iut0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	ENDDO
	   ENDIF
C
Cpre	IF (lda2.gt.lda1) THEN              !-------------
       IF (iutcnt.lt.48) THEN             !----------------
C 2nd day from current year:
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=103) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
C	  2nd day :
       DO ii=0,23
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	if (iutcnt.eq.48) exit  !++++++++++++++++
	ENDDO
	                   ELSE
	GOTO 777
	                   ENDIF           !-------------------
	IF (lda2.gt.lda1) THEN              !-------------
C 3rd day from current year:
C-	 do ii=0,23
C-	read(15,37,end=103) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=103) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
C	  3rd day :
       DO ii=0,23
	if (iutcnt.lt.48) then
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	if (iutcnt.eq.48) exit  !++++++++++++++++
              	else
	exit
              	endif
	ENDDO
	goto 103
	                   ELSE
	GOTO 777
	                   ENDIF           !-------------------
C
  103	close(unit=15)
C Next year if necessary:
Cpre 777       if (iutcnt.lt.72) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
 777       if (iutcnt.lt.48) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	iyear1=iyear+1
	call blet4(iyear1,AYEAR)
	AYR=AYEAR(3:4)
C-	infile(13:14)=AYR
		infile(16:19)=AYEAR  ! 
	open(15,file=infile,action='READ')
C
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=104) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
C	  next day :
       DO ii=0,23
	if (iutcnt.lt.48) then
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
	if (iutcnt.eq.48) exit  !++++++++++++++++
              	else
	exit
              	endif
	ENDDO
      endif	                !>>>>>>>>>>>>>>>>>>>>>
C	     if (iutcnt.lt.72) then   !>>>>>>>>>>>>>>>>>>>>>>>>>>>
	if (iutcnt.lt.48) THEN  !++++++++++++++++
C-	 do ii=0,23
C-	read(15,37,end=102) DYEAR,DMN,DDY,ind24(ii)
C-	read(15,37,end=104) DYR,DMN,DDY,(ind24(ii),ii=0,23)
	read(15,37,end=102) dstread,(ind24(ii),ii=0,23) ! Dst
C-	 enddo
C	  next day :
       DO ii=0,23
	if (iutcnt.lt.48) then
       inpn(iutcnt)=ind24(ii)
      iutcnt=iutcnt+1
		if (iutcnt.eq.48) exit  !++++++++++++++++
              	else
	exit
              	endif
	ENDDO
      endif	                !>>>>>>>>>>>>>>>>>>>>>
  104	close(unit=15)
C
Cpre   38 format(72(1X,I3))
   38 format(48(1X,I4))
C Output matrices:
Cpre 	write(*,38) (inpn(k),k=0,71)
Cpre	write(11,38) (inpn(k),k=0,71)
 	write(*,38) (inpn(k),k=0,47)
	write(11,38) (inpn(k),k=0,47)
Cpre	do jk=0,71
	do jk=0,47
	inpn_pre(jk)=inpn(jk)
	enddo
  177	CONTINUE
   27 close(unit=10)
      close(unit=11)
C
C
   35      write(*,*) infile
      pause ' ' 
      STOP
       END

C***********************************************************
