C .......................................................Mar 2014
C RMSE between foF2-obs and fcF2-fitTEC, 
C RMSE between foF2-obs and fcF2-CCIR,  at given sites
C 3 days in Sep. 2002, 3 days in Oct. 2003; 31 stations
C
C
C Input files stYRMNDY.out [ fcF2-fitTEC, fcF2-CCIR]
C Input files stYRMNDY.br stYRMNg.txt (fcF2// from TECgps)
C & styrf.br(from IDCE) 	????????????????
C
C <<< to replace only line(s) for given day(s)
C 
C Output: annual file stYRf.br for Conver & /dat8/10/styrmn.txt
C
      PROGRAM DERMSHF1
C---------------------------------------------------------------
C data for 24 UT=0,1,2,...23hUT daily
C
C
C*********TEST
	CHARACTER*128 OUTFILE1,OUTFILE2,infilest,infile1,infile2
	character*2 ayr,amn,ST,sts(31),cyr,cmn,cdy
	+,ADY,stinp
	INTEGER*2 IDY,KWIND(0:23)
	dimension glats(31),glons(31)
	+,CC(7,0:23),XAV(0:23)
	character*1 fm
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 STAT,STATS(31)
	dimension im(12),xobs(0:23),xcir(0:23),xtec(0:23)
	+,hsct(0:23),hscc(0:23)
      COMMON /BLM/ STAT,GLAT,GLON
			COMMON /BL1/CC,XAV
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA STS
	+/'at','ch','co','ds','eg','ga','gs','jr','kk','ld'
     +,'mg','mh','mm','mo','nq','ok','pa','ro','rv','sd'
     +,'sf','so','ss','tk','tq','tr','tz','vt','wk','wp'
     +,'yg'/
c YEAR MMDD UThr LThr XHI  SSN  COV  Kpm    L  Glati Glong Mlati Mlong MoDip  hmF2  foF2    NmF2   Nes      hpl    Nepl   ECbot  ECtop   ECpl   TEC    TAU  h05b  h05t   Hsc
c    1    2    3    4   5    6    7    8    9     10    11    12    13    14    15    16      17    18       19      20      21     22     23    24     25    26    27    28
c         x         x         x         x         x         x         x         x         x         x         x         x         x         x         x         x         x
c        10        20        30        40        50        60        70        80        90       100       110       120       130       140       150       160       170
c 2016  601   .0  1.6 115.  36.  91. 2.7  1.56  38.4  23.6  36.7 103.6  47.1 331.5  5.01  311057.  24179. 20200.    296.   1.87   9.29   3.29  14.45  464.5 274.2 481.4  265.0

C
	IRUN=1	 ! 1 for foF2, 2 for hmF2
c
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C read stations coordinates
	infilest='inputs1.inp'
  76	format(1X,I2,1X,F5.1,1X,F5.1,1X,A4,1X,A2)
   77	format(30X,F5.1,1X,F5.1,40X,A4,9X,A2)
		    OPEN(109,FILE=INFILEST,action='READ')
	do i=1,31
	read(109,77,end=78) glat,glon,stat,stinp
	if (stinp.eq.sts(i)) then
	write(*,76) i,glat,glon,stat,stinp
	glats(i)=glat
	glons(i)=glon
	stats(i)=stat
	 endif
	enddo
   78	close(unit=109)

C
  201	      WRITE(*,*)' ENTER yr,mn :'
		READ(*,15) AYR,AMN
   15	FORMAT(A2)
  202	      WRITE(*,*)' ENTER DY :'
		READ(*,15) ADY
	read(ayr,*) yr
	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF
	read(amn,*) xmn
	mn=int(xmn)
		read(ady,*) xdy
 	idy=int(xdy)


C start foF2, hmF2 or TEC
	outfile1='dermshf1.txt'
	outfile2='dermshf2.txt'
	OPEN(110,FILE=outfile1,access='APPEND')
	OPEN(111,FILE=outfile2,access='APPEND')
	fm='f' !Temp
	infile1='d:\web\graf\2002\styrf.br'	! foF2 -obs.
	infile1(15:16)=AYR
	infile1(20:21)=AYR
	infile2='styrmndy.out'
	infile2(3:4)=AYR
	infile2(5:6)=AMN
	infile2(7:8)=ADY

   75	format(3A2,2X,24(F3.1,2X))

  199	nds=1
	sumsc=0.
	sumst=0.
	cnttot=0.
C    
	DO 88 ist=1,31
	st=sts(ist)
	write(*,18) st,ayr,amn,ady
	write(110,18) st,ayr,amn,ady
	write(111,18) st,ayr,amn,ady
	infile1(18:19)=st
	infile2(1:2)=st
C Read foF2obs.
	OPEN(109,FILE=infile1,action='READ')
	do k=0,23
	xobs(k)=0.
	xcir(k)=0.
	xtec(k)=0.
	enddo
  198	read(109,75,end=197) CYR,CMN,CDY,(xobs(k),k=0,23)
	do k=0,23
	cc(7,k)=xobs(k)
	enddo
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then
	goto 197
	else
	do k=0,23
	do j=2,7
	cc(j-1,k)=cc(j,k)
	enddo
	cc(7,k)=0.
	enddo
	goto 198
	endif
  197	close(unit=109)
	call rmedian7(7)
C Read foF2-tecfit, foF2-ccir
	OPEN(108,FILE=infile2,action='READ')
	read(108,79) txt  !extra line
	do k=0,23
	read(108,178) xmlat,xmlon,xmodip,xtec(k),hsct(k)
	enddo
	read(108,79) txt  !extra line
	do k=0,23
	read(108,178,end=81) xmlat,xmlon,xmodip,xcir(k),hscc(k)
	enddo
   81	close(unit=108)

C
C start cycle on stations
   79 format(A128)
  178 format(57X,3(1X,F5.1),7X,F5.2,80X,F6.0)

c
	glat=glats(ist)
	glon=glons(ist)
	sumc=0.
	sumt=0.
	cnt=0.
	rmsc=0.
	rmst=0.
	do k=0,23
	if (xobs(k).gt.0.) then
	sumc=sumc+(xobs(k)-xcir(k))**2
	sumt=sumt+(xobs(k)-xtec(k))**2
	 cnt=cnt+1.
	xpar=xobs(k)**2
	xmed=xav(k)**2
	delog=0.
	call windex(xpar,xmed,delog,iw)
	KWIND(k)=iw
	write(*,19) k,xobs(k),xtec(k),iw,hscc(k),hsct(k)
	write(111,19) k,xobs(k),xtec(k),iw,hscc(k),hsct(k)
	endif
	enddo
	if (cnt.gt.0.) then
	rmsc=sqrt(sumc/cnt)
	rmst=sqrt(sumt/cnt)
	endif
	write(*,17) glat,glon,xmlat,xmlon,xmodip,rmsc,rmst,cnt
	write(110,17) glat,glon,xmlat,xmlon,xmodip,rmsc,rmst,cnt
c
	sumsc=sumsc+sumc
 	sumst=sumst+sumt
	cntot=cntot+cnt
   88	continue
c	
	 rec=0.
	ret=0.
	if (cntot.gt.0.) then
	rec=sqrt(sumsc/cntot)
	ret=sqrt(sumst/cntot)
	endif
	write(*,16) rec,ret,cntot
	write(110,16) rec,ret,cntot
C
c ***************************************************************
C
   16	format('%',2(1X,F5.1),1X,F4.0)
   17 format(1X,5(1X,F5.1),2(1X,F7.2),1X,F4.0)
   18	format('%',4(1X,A2))
   19	format(1X,I2,2(1X,F4.1),1X,I2,2(1X,F6.1))

C
C++
C output 
C
C
	close(unit=110)
	close(unit=111)
  111	format(A6,1X,24(I4,1X))
	GOTO 33
C
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
      write(*,*) outfile1,infile1,infile2
      pause ' ' 
   34   STOP
       END

C***********************************************************
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !NEW+7
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
      integer function ndoy(iyr,imn,idy)
C To define day-of-year
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
