      program extparmedfht4
C.......................................................Aug 2020
C
C Select results for Jan,Apr,July,Oct (4 seasons)
C
C Compile 8st x 4month x 24UT TEC file
C monthly median data or model
C
      character*120 infile,outfile,txt
		character*2 AYR,st,stat(8)
	character*4 AYEAR
      dimension tec(8,288),res(96)
	DATA stat/'du','ho','dw','pg','gg','kk','yk','ti'/
C
Crem      infile='stYEAR_1.out' ! CCIR	model
C+         iflag=1
C+	infile='stYEARfh_2.out' ! GMF2	model
C+         iflag=2
C
	iflag=3
C
C+	AYEAR='2014' 
      AYEAR='2019' 
c+      AYR='14'
      AYR='19'
	read(ayr,*) ryr
	iyr=int(ryr)
c
   31 format(2(1X,A25))
   32 format(A2)
C
C
      outfile='tecYEARmn4.txt'
	outfile(4:7)=AYEAR
	OPEN(10,file=outfile,access='APPEND')
	if (iflag.eq.1) then
	write(*,32) ' ccir',AYR
	write(10,32) ' ccir',AYR
	endif
	if (iflag.eq.2) then
	write(*,32) ' gmf2',AYR
	write(10,32) ' gmf2',AYR
	endif
	if (iflag.eq.3) then
	write(*,32) ' jpl',AYR
	write(10,32) ' jpl',AYR
	endif

C Cycle on stat:
         DO 70 ist=1,8
       st=stat(ist)
C-      write(*,*) ' Enter st 00 for stop:'
C-	read(*,*) st
C-	if (st.eq.'00') goto 77
        select case(iflag)
      case(1)
      infile='stYEAR_1.out' ! CCIR	model
	infile(3:6)=AYEAR
       infile(1:2)=st
	case(2)
      infile='stYEARfh_2.out' ! GMF2	model
	infile(3:6)=AYEAR
       infile(1:2)=st
	case(3)
	infile='d:\web\graf\YEAR\styr.med' ! TEC-jpl data obs
      infile(13:16)=AYEAR
	infile(20:21)=AYR
	infile(18:19)=st
      end select
	write(*,31) infile,outfile
C
	OPEN(11,file=infile,action='READ')
	if (iflag.lt.3) then
	do k=1,7
	read(11,*) txt   ! title line
	enddo
C read model TEC
       DO jj=1,288
	read(11,33,end=51) tec(ist,jj)
	enddo
                     else
       DO jj=1,288
	read(11,34,end=51) tec(ist,jj)
	enddo
              	endif
   51   close(unit=11)
C
C output Select Jan,Apr,Jul,Oct
      i=0
      DO ii=1,12,3
	k1=(ii-1)*24+1
	k2=k1+23
	DO kk=k1,k2
      i=i+1
	res(i)=tec(ist,kk)
	ENDDO
	ENDDO    
C
        write(*,35) (res(k),k=1,96)
	write(10,35) (res(k),k=1,96)
   70 CONTINUE ! 
c++++++++++++++++++++++++++++++++++++++++++++++++++++++
   77	close(unit=10)
C
   33 format(144X,F6.2) ! TEC from IRI-Plas.out file
   34 format(26X,F5.1) ! TEC-jpl obs
C   35 format(288(1X,F5.1)) ! tec 
   35 format(96(1X,F5.1)) ! tec 
       pause ' '
	STOP
	END