      program extpianiaWm4
C..........................................................May 2021
C Output if date + 4 lines for each day 
C..........................................................Apr.2021
C 1h UT indices WU, WL, WE quantifying ion activity indices 
C JPL IONEX GIM-TEC extracted from JPLI for 00, 15, 30, 45 min.
C.........................................................Dec. 2020
C Include weight e(glat)
C
C.........................................................Nov. 2020
C Weighted PIA -pos ion activity, NIA - neg ion activity
C extracted from global Wc(TEC) index derived from JPL GIM-TEC (IONEX)
C for ADY_pre and forecast for DD2
C
	DIMENSION weg(4),IM(12)
	INTEGER*4 iwneg(0:96),iwpos(0:96),iwran(0:96),idat(0:96)
	CHARACTER*128 INFILE,OUTFILE
C	+,indate !global weighted WN,WL,WU = range index
	CHARACTER*2 AYR,AUT,AMN,ADY,AMM
C+	+,AMN_cur,DD2,AMN_pre
C+	+,ADY_pre
	CHARACTER*4 YEAR,AUTOUT(0:95),TTMM
	CHARACTER*2 wul
C	+,PYR,PMN,PDY,AYRI,AMNI,YEAR_pre
	INTEGER ivsr(0:72) !  set of Wf indices for long=-180:5:180 at given lati
		DATA WEG/0.,0.6931,1.0986,1.3863/  ! =ln1, ln2, ln3, ln4
            DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C+	indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 
C+	open(10,file=indate)							 
C+	read(10,799) YEAR,AMN_cur,DD2,YEAR_pre,AMN_pre,ADY_pre,lda,lda_pre  !FORMAT NUMBER = 799
C+	WRITE(*,798) YEAR,AMN_cur,DD2,YEAR_pre,AMN_pre,ADY_pre,lda,lda_pre !FORMAT NUMBER = 798
C+	close(unit=10)
C+  798	format(' YEAR, AMN, DD2 = ',A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))
C+  799	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))	
C
	nn=0
	do iut=0,23
	call blet2(iut,aut)
	TTMM(1:2)=AUT
	do mm=0,45,15
	call blet2(mm,amm)
	TTMM(3:4)=AMM
	autout(nn)=TTMM
	nn=nn+1
	enddo
	enddo
C      infile='d:\web\dlg\YY\MM\wcMMDDUTMM.jYY'   ! current mn	  Observed 0,1`5,30,45min
      infile='d:\web\gtc\YY\MM\wsMMDDUTMM.sYY'   ! current mn Shub. W(GTEC) index
C
C      outfilen='d:\web\graf\datw\wlnYYmm.txt'   !  Cnt(W-) 	 WL	Observed 0,1`5,30,45min
C      outfilep='d:\web\graf\datw\wupYYmm.txt'   !  Cnt(W+) 	 WU	Observed 0,1`5,30,45min
C      outfiler='d:\web\graf\datw\werYYmm.txt'   !  Cnt(Wrange) WE	Observed 0,1`5,30,45min
      outfile='d:\web\graf\dats\wlnYYms4.txt'   !  Cnt(W-) 	 WL	Observed 0,1`5,30,45min
C-      outfilep='d:\web\graf\dats\wupYYms4.txt'   !  Cnt(W+) 	 WU	Observed 0,1`5,30,45min
C-      outfiler='d:\web\graf\dats\werYYms4.txt'   !  Cnt(Wrange) WE	Observed 0,1`5,30,45min
C
   17 format(A2)
   31 FORMAT('YYMMDD',96(1X,A4),3X,'DAY')
   32 FORMAT(73(1X,I4))
C
C Yearly cycle
C
      DO 500 iyear=2000,2017  ! 
	call blet4(iyear,YEAR)
C
      AYR=YEAR(3:4)  ! for current day  	
C+	IYR=int(ryr)   ! current yr
      iyr=iyear-iyear/100*100
	z1=iyear/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyear) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
	infile(12:13)=AYR
	infile(30:31)=AYR
	outfile(21:22)=AYR
C
C Output one of 3 parameters:
C
         DO 400 jc=1,3
	if (jc.eq.1) wul='up'
	if (jc.eq.2) wul='ln'
	if (jc.eq.3) wul='er'
      outfile(19:20)=wul
	OPEN(11,file=outfile)
C
C month-to-month cycle
C
	DO 51 imn=1,12
	call blet2(imn,AMN)
	mndy=im(imn)
	infile(15:16)=amn
	infile(20:21)=amn
C
C  Day-to-day cycle
C
      DO 52 idy=1,mndy
       call blet2(idy,ADY)
	infile(22:23)=ady
C
C?  330	CONTINUE
C
C>>	IF ((AMN.eq.'01').and.(ADY.eq.'01')) THEN
C>>	write(*,31) (autout(k),k=0,95)
C>>	write(11,31) (autout(k),k=0,95)
C>>	write(12,31) (autout(k),k=0,95)
C>>	write(13,31) (autout(k),k=0,95)
C>>	ENDIF
C
C  UT cycle
C
      DO k=0,96
	iwneg(k)=0
	iwpos(k)=0
	iwran(k)=0
	ENDDO
	 wdyp=0.
	wdyn=0.
	wdyr=0.
C
C
      iutmm=0
	DO 53 iut=0,23
	call blet2(iut,AUT)
      infile(24:25)=aut
C
C Minute cycle
C
      DO 200 imm=0,45,15
	call blet2(imm,AMM)
	infile(26:27)=amm
   	OPEN(10,file=infile,action='READ')
	sumn=0.		 ! count of Wf >=1
	sump=0.		 ! count of Wf <=-1
	icntp=0
	swegp=0.
      icntn=0
	swegn=0.
C
C/ cycle for lats:
       glat=-90.0	                  ! AD
	  do 54 ilat=1,71
	glat=glat+2.5				  ! AD
	elat=1.0+0.0001235*glat**2	  ! AD
	  read(10,32,end=153) (ivsr(k),k=0,72) 
C
	DO 333 ilon=0,72
          if (ivsr(ilon).gt.1) then
        iad=ivsr(ilon)
	sump=sump+elat*weg(iad)*ivsr(ilon)  ! AD
	icntp=icntp+1
	swegp=swegp+weg(iad)
	goto 333
	endif
          if (ivsr(ilon).lt.-1) then
        iad=-ivsr(ilon)
	sumn=sumn+elat*weg(iad)*ivsr(ilon)   ! AD
	icntn=icntn+1
	swegn=swegn+weg(iad)
	goto 333
	endif
  333	CONTINUE		! end long cycle
   54 CONTINUE        ! end lat cycle
  153      xpos=0.
      if (icntp.gt.0.) then
		xpos=sump/icntp		 ! /cnt(Wf+)
	endif
      xneg=0.
      if (icntn.gt.0.) then
			xneg=sumn/icntn	  ! /cnt(Wf-)
	endif
	xrange=xpos-xneg
	wdyp=wdyp+xpos
	wdyn=wdyn+xneg
      wdyr=wdyr+xrange
      iwneg(iutmm)=nint(xneg*100.)
	iwpos(iutmm)=nint(xpos*100.)
	iwran(iutmm)=nint(xrange*100.)
	iutmm=iutmm+1
  	close(unit=10)
  200	continue  !end minute cycle
   53	CONTINUE           ! end UT cycle
       iwpos(96)=nint(wdyp/96.*100.)
	iwneg(96)=nint(wdyn/96.*100.)
	iwran(96)=nint(wdyr/96.*100.)
C
	if (jc.eq.1) then
C	write(*,33) AYR,AMN,ADY,(iwpos(k),k=0,96)
	write(11,34) YEAR,AMN,ADY,iwpos(96)
	write(11,33) (iwpos(k),k=0,23)
	write(11,33) (iwpos(k),k=24,47)
	write(11,33) (iwpos(k),k=48,71)
	write(11,33) (iwpos(k),k=72,95)
	if ((AMN.eq.'01').and.(ADY.eq.'01')) then
	close(unit=11)
	   	OPEN(12,file=outfile,action='READ')
	read(12,34,end=70) YEAR,AMN,ADY,isum
	read(12,33,end=70) (idat(k),k=0,23)
	read(12,33,end=70) (idat(k),k=24,47)
	read(12,33,end=70) (idat(k),k=48,71)
	read(12,33,end=70) (idat(k),k=72,95)
	CONTINUE
   70	close(unit=12)
 	   OPEN(11,file=outfile)
	endif
	endif
C
      if (jc.eq.2) then
C	write(*,33) YEAR,AMN,ADY,(iwneg(k),k=0,96)
	write(11,34) YEAR,AMN,ADY,iwneg(96)
	write(11,33) (iwneg(k),k=0,23)
	write(11,33) (iwneg(k),k=24,47)
	write(11,33) (iwneg(k),k=48,71)
	write(11,33) (iwneg(k),k=72,95)
	if ((AMN.eq.'01').and.(ADY.eq.'01')) then
	close(unit=11)
	   	OPEN(12,file=outfile,action='READ')
	read(12,34,end=71) YEAR,AMN,ADY,isum
	read(12,33,end=71) (idat(k),k=0,23)
	read(12,33,end=71) (idat(k),k=24,47)
	read(12,33,end=71) (idat(k),k=48,71)
	read(12,33,end=71) (idat(k),k=72,95)
	CONTINUE
   71	close(unit=12)
 	   OPEN(11,file=outfile)
	endif
	endif
C
        if (jc.eq.3) then
C	write(*,33) YEAR,AMN,ADY,(iwran(k),k=0,96)
	write(11,34) YEAR,AMN,ADY,iwran(96)
	write(11,33) (iwran(k),k=0,23)
	write(11,33) (iwran(k),k=24,47)
	write(11,33) (iwran(k),k=48,71)
	write(11,33) (iwran(k),k=72,95)
	if ((AMN.eq.'01').and.(ADY.eq.'01')) then
	close(unit=11)
	   	OPEN(12,file=outfile,action='READ')
	read(12,34,end=72) YEAR,AMN,ADY,isum
	read(12,33,end=72) (idat(k),k=0,23)
	read(12,33,end=72) (idat(k),k=24,47)
	read(12,33,end=72) (idat(k),k=48,71)
	read(12,33,end=72) (idat(k),k=72,95)
	CONTINUE
   72	close(unit=12)
 	   OPEN(11,file=outfile)
	endif
	endif
C
	write(*,*) YEAR,AMN,ADY,wul
   52 CONTINUE  ! daily cycle
   51 CONTINUE  ! Monthly cycle
      close(unit=11)
c//	close(unit=12)
C//	close(unit=13)
  400 CONTINUE  ! Case cycle
  500	CONTINUE  ! Yearly cycle
   34 format(A4,2(1X,A2),1X,I4)
C   33 format(A4,2(1X,A2),96(1X,I4),2X,I4)
   33 format(24(1X,I4))
      pause ' '
	STOP
	END
