      program extvsmlat
C..................................................................................Dec. 2018
C Extract geogr. lats (~ 8 mlats) at glongs for IONEX -180:5:180
C     (1) mlat -70
C     (2) mlat -50
C     (3) mlat -30
C     (4) mlat -10
C     (5) mlat  10
C     (6) mlat  30
C     (7) mlat  50
C     (8) mlat  70
C Data : dip.txt (geogr. lats of mdip =0 deg. at geogr. longs -180:5: 180)
      dimension glats(8,0:72),glons(0:72),xlats(0:72),xlons(0:72)
	CHARACTER*50 outfile,infile,txt
	CHARACTER*1 cc
	CHARACTER*3 ccc
C	*,DIP(0:72)
C      data DIP/
C     +   2.60,  1.75,  1.05,  0.45, -0.10, -0.61, -1.20, -1.79, -2.40
C     +, -3.20, -3.65, -4.27, -4.94, -5.68, -6.50, -7.40, -8.45, -9.55
C     +,-10.60,-11.47,-12.10,-12.18,-11.62,-10.37, -8.45, -6.00, -3.01
C     +,  0.34,  3.34,  5.89,  7.97,  9.49, 10.50, 11.17, 11.46, 11.57
C     +, 11.52, 11.37, 11.19, 10.92, 10.54, 10.05,  9.41,  8.73,  8.07
C     +,  7.50,  7.20,  7.05,  7.03,  7.12,  7.29,  7.47,  7.65,  7.84
C     +,  7.91,  7.93,  7.87,  7.76,  7.58,  7.47,  7.45,  7.52,  7.58
C     +,  7.71,  7.68,  7.51,  7.25,  6.80,  6.20,  5.33,  4.47,  3.50
C     +,  2.60/
	outfile='extvsmlat.dat'
	OPEN(11,file=outfile)
	infile='mapmlatXXX.out'
	cc=','
C
      ylon=-185.0
	DO lon=0,72
	ylon=ylon+5.0
	glons(lon)=ylon
	ENDDO
C
   30 format(A50)
C
	DO 50 ii=1,8
	if (ii.eq.1) ccc='_70'
	if (ii.eq.2) ccc='_50'
	if (ii.eq.3) ccc='_30'
	if (ii.eq.4) ccc='_10'
	if (ii.eq.5) ccc='10_'
	if (ii.eq.6) ccc='30_'
	if (ii.eq.7) ccc='50_'
	if (ii.eq.8) ccc='70_'
	infile(8:10)=ccc
      OPEN(10,file=infile,action='READ')
	do k=1,7
	read(10,30) txt ! extra lines
	enddo
C
      DO kk=0,72
	read(10,31,end=51) xlats(kk),xlons(kk)
	if (xlons(kk).gt.180.0) xlons(kk)=xlons(kk)-360.0
C-	if (xlons(kk).le.180.0) xlons(kk)=xlons(kk)+360.0
	enddo
C
	do kk=0,72
	glon=glons(kk)
C
	do k=1,72
	ylon=glon+360.0
	glats(ii,kk)=99.9
	if ((glon.ge.xlons(k-1)).and.(glon.lt.xlons(k))) then
	glats(ii,kk)=xlats(k-1)+(xlats(k)-xlats(k-1))/
	&(xlons(k)-xlons(k-1))*(glon-xlons(k-1))
c-	if ((ylon.ge.xlons(k-1)).and.(ylon.lt.xlons(k))) then
c-	glats(ii,kk)=xlats(k-1)+(xlats(k)-xlats(k-1))/
c-	&(xlons(k)-xlons(k-1))*(ylon-xlons(k-1))
	 exit
	endif
	enddo
	enddo
C
   51 close(unit=10)
   50 CONTINUE ! next mlat
C
C output results
      DO kk=0,72
      write(*,32) cc,glons(kk),cc,glats(1,kk),cc,glats(2,kk),cc
	+,glats(3,kk),cc,glats(4,kk),cc,glats(5,kk),cc
	+,glats(6,kk),cc,glats(7,kk),cc,glats(8,kk)
      write(11,32) cc,glons(kk),cc,glats(1,kk),cc,glats(2,kk),cc
	+,glats(3,kk),cc,glats(4,kk),cc,glats(5,kk),cc
	+,glats(6,kk),cc,glats(7,kk),cc,glats(8,kk)
	ENDDO
   31 format(46X,F5.1,1X,F5.1)
   32 format(5X,'&',A1,F6.1,8(A1,F5.1))
	pause ' '
	STOP
	END

c===============================================================================
