      program fcnrmsd1
C.......................................................July 2015
C Normalized NRMSD Deviation of fcF2 maps at EQ-quiet and EQ-storm
C Moving window: = 24 grids around EQ epicenter
C Select area +-10 deg: 4 lats>glat,+4lats<glat; 2longs>glong+2 longs <glong
C
C Regarding fc-map and std for Geom-qdays and Wp-qdays.  
C+ Vsigma Q days ranked for 27-prec days
	dimension fx(71,0:72),fy(71,0:72),IM(12)
	character*64 eqlist,infile1,infile2,outfile
	character*4 AYEAR
	character*2	AYR,AMN,ADY,AUT,BYR,BMN,BDY,QYR,QMN,QDY
	character*1 sq
	CHARACTER*6 YYMMDDMAX,YYMMDDMIN
	REAL ut1
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/ 
C
   31	format(A33)
   33	format(73(1X,F4.1))
   35	format(1X,A4,2A2,1X,F5.2,1X,3(1X,F6.2),2(1X,F5.2),1X,F5.1)
   36	format(A1)
C
	ivcnt=0
C
   98 write(*,*) ' Enter s or q for EQ-storm or EQ-quiet: '
	read(*,36) sq

	outfile='EQnrmsdvx.txt'	  ! 
	outfile(9:9)=sq
	OPEN(15,file=outfile)
	if (sq.eq.'s') then
	write(*,*) ' EQ storm'
	write(15,*) ' EQ storm'
	else
	write(*,*) ' EQ quiet'
	write(15,*) ' EQ quiet'
	endif
      	write(*,*) ' Vs rank Qdays'
		write(15,*) ' Vs rank Qdays'
C
  100	eqlist='exteq6s.txt'
	eqlist(7:7)=sq
	open(13,file=eqlist,action='READ')
	eqcnt=0
  101	read(13,35,end=27,err=26) AYEAR,BMN,BDY,UT1
 	+,glat,glon,depth,eqmag,hlt,xhi
	BYR=AYEAR(3:4)
	if (BYR.eq.'16') goto 27   ! end of EQs
C
	read(BYR,*) ryr
	iyr=int(ryr)
		if(int(ryr/4.)*4.eq.iyr) THEN 
		 im(2)=29
	ndnyr=366
	                          ELSE
	IM(2)=28
	ndnyr=365
	ENDIF
C
	read(BMN,*) rmn
	imn=int(rmn)
	read(BDY,*) rdy
	idy=int(rdy)
C
C Calculate rank-27 Qday:
	call subrank(iyr,imn,idy,YYMMDDMAX,jmax,YYMMDDMIN,jmin)
	QYR=YYMMDDMIN(1:2)
	QMN=YYMMDDMIN(3:4)
	QDY=YYMMDDMIN(5:6)

	IF (ut1.lt.0.) THEN
	kut1=0
	                ELSE
	ut2=ut1+0.005
	kut1=int(ut2)+1
C
	if (kut1.eq.24) then
	kut1=0
	idy=idy+1
	   if (idy.gt.im(imn)) then
	   idy=1
	   imn=imn+1
      	if (imn.gt.12) then
      	imn=1
      	iyr=iyr+1
      	endif
	   endif
      endif
	ENDIF
C
	call blet2(iyr,AYR)
	call blet2(imn,AMN)
	call blet2(idy,ADY)
	call blet2(kut1,AUT)
C
	infile1='d:\web\dfs\YR\MN\fcMNDDUT.jYR' ! Q-day
C
	infile1(12:13)=QYR
	infile1(15:16)=QMN
	infile1(20:21)=QMN
	infile1(28:29)=QYR
C
	infile1(22:23)=QDY
	infile1(24:25)=AUT
	OPEN(11,FILE=infile1,action='READ')
	infile2=infile1
	infile2(12:13)=AYR
	infile2(15:16)=AMN
	infile2(20:21)=AMN
	infile2(28:29)=AYR
	infile2(22:23)=ADY

	OPEN(12,FILE=infile2,action='READ') ! EQ day 
	    do ilat=1,71  !read  for EQ-day
	read(12,33,end=233,err=26) (fy(ilat,k),k=0,72)
	enddo
  233	close(unit=12)  !

	qlat=-90.0
	    do ilat=1,71  !read  for q-day
	qlat=qlat+2.5
	read(11,33,end=133,err=26) (fx(ilat,k),k=0,72)
	if ((glat.ge.qlat).and.(glat.lt.qlat+2.5)) iqlat=ilat
	enddo
  133	close(unit=11)  !
C 
	qlon=-185.
	xlon=glon
	if (glon.gt.180.) xlon=glon-360.
	do ilon=0,71
	qlon=qlon+5.
	if (qlon.ge.180.) qlon=qlon-360.

	if ((xlon.ge.qlon).and.(xlon.lt.qlon+5.0)) iqlon=ilon
	enddo
	iqlon_1=iqlon-1
	if (iqlon_1.lt.0) iqlon_1=iqlon_1+70
	iqlon1=iqlon+1
	if (iqlon1.gt.72) iqlon1=iqlon1-72
	iqlon2=iqlon+2
	if (iqlon2.gt.72) iqlon2=iqlon2-72

	fxav=0.
	cnt=0.
      	do ilat=iqlat-3,iqlat+4
	if ((ilat.ge.iqlat-1).and.(ilat.lt.iqlat+3)) then
c	do ilon=iqlon-1,iqlon+2
      fxav=fxav+fx(ilat,iqlon_1)+fx(ilat,iqlon)+fx(ilat,iqlon1)
     $+fx(ilat,iqlon2)
	cnt=cnt+4.
c	enddo
	               else
c	do ilon=iqlon,iqlon+1
      fxav=fxav+fx(ilat,iqlon)+fx(ilat,iqlon1)
	cnt=cnt+2.
c	enddo
	endif
		enddo
	fav=fxav/cnt
C  std
	devx=0.
	devxy=0.
      	do ilat=ilat-3,ilat+4
	    if ((ilat.ge.iqlat-1).and.(ilat.lt.iqlat+3)) then
c	do ilon=iqlon-1,iqlon+2
	devx=devx+(fav-fx(ilat,iqlon_1))**2.+(fav-fx(ilat,iqlon))**2.
	&+(fav-fx(ilat,iqlon1))**2.+(fav-fx(ilat,iqlon2))**2.
	devxy=devxy+(fx(ilat,iqlon_1)-fy(ilat,iqlon_1))**2.
	&+(fx(ilat,iqlon)-fy(ilat,iqlon))**2.
	&+(fx(ilat,iqlon1)-fy(ilat,iqlon1))**2.
	&+(fx(ilat,iqlon2)-fy(ilat,iqlon2))**2.
C	enddo
                                else
C	do ilon=iqlon,iqlon+1
	devx=devx+(fav-fx(ilat,iqlon))**2.+(fav-fx(ilat,iqlon1))**2.
	devxy=devxy+(fx(ilat,iqlon)-fy(ilat,iqlon))**2.
	&+(fx(ilat,iqlon1)-fy(ilat,iqlon1))**2.
C	enddo
                   endif
	enddo
	stdx2=devx/cnt
		stdx=0.
	if (stdx2.gt.0.) stdx=sqrt(stdx2)
	rms=0.0
	if (devxy.gt.0.0) rms=sqrt(devxy/cnt)
	rmsn=0.0
	if (stdx.gt.0.) rmsn=rms/stdx
C Output results:
      write(*,34) AYEAR,BMN,BDY,UT1,glat,glon,depth,eqmag,hlt,xhi
	+,fav,stdx2,rms,rmsn,YYMMDDMIN,AUT
	write(15,34) AYEAR,BMN,BDY,UT1,glat,glon,depth,eqmag,hlt,xhi
	+,fav,stdx2,rms,rmsn,YYMMDDMIN,AUT
	 ivcnt=ivcnt+1
	GOTO 101 ! Next EQ

   27	close(unit=15)
C
   34	format(1X,A4,2A2,1X,F5.2,1X,3(1X,F6.2),2(1X,F5.2),1X,F5.1,1X,F5.2
     +,3(1X,F7.3),1X,A6,1X,A2)
	goto 400
   26	write(*,*) 'Error in input file=',eqlist
  400	continue ! 
	write(*,*) ivcnt
	pause ' '
	stop
	END
C
