      program lag1hp0jm
C..............................................................Oct 2022
C++ SSN = 0, Hpo < 3.0 (952 EQ events)
C
C..Add Hpo, Apo 1h indices.....................................Aug 2022
C JPL 1h indices based on -15d median geomag. wi indices
C WUmax from -24h:tkp:+24h
C WLmin from -24h:tkp:+24h
C WEmax from -24h:tkp:+24h
C
      CHARACTER*64 infile,outfile,infileu,infilel,infiler,txt
	+,infhpo
	CHARACTER*2 AYR,AYR_pre,AYR_nex
	CHARACTER*4	AYEAR,AYEAR_pre,AYEAR_nev
	DIMENSION wu(0:71),wl(0:71),we(0:71),hpo(0:71)
C
Cpre      infile='exaphs0.txt'
      infile='cateqhpo0.txt'  !Catalog of 952 days SSN=0, Hpo<3  read(10,
	infhpo='d:\Apkp\Hpo\HpoYEAR.txt'						  !read(15,
	outfile='wules0hpojm.txt'								  !write(14,
	infileu='d:\web\graf\datm\wupYRjm.txt'					  !read(11,
	infilel='d:\web\graf\datm\wlnYRjm.txt'					  !read(12,
	infiler='d:\web\graf\datm\werYRjm.txt'					  !read(13,
C
       OPEN(10,file=infile,action='READ')
       OPEN(14,file=outfile)
C ryear     lda mn dd iut1 Hpo     Apo  nn      
C 1996.033  13  1 13  3.5  5.667   67    1
C
   30 FORMAT(1X,F8.3,1X,I3,2(1X,I2),1X,F4.1,1X,F6.3,2(1X,I4))
   32 format(1X,F8.3,1X,I3,4(1X,I2),2(1X,F6.2),1X,I4,2(1X,F4.1)
     +,3(1X,I4))
   33 format(3I2,24(1X,F4.2))
C
C
	ndy=0
C
      lda_out=0
C
C SSN=0 Hpo <3 events
        DO 41 iev=1,952  ! Events	Catalog of 952 days SSN=0, Hpo<3  
C 
	DO k=0,71
	wu(k)=0.
	wl(k)=0.
	we(k)=0.
	ENDDO
C
Cpre    	read(10,*,end=50) ryear,lda,imn,idy,thpo,hpomax,iapo,nn
     	read(10,32,end=50)  ryear,lda,imn,idy,iuteq,imm,glat,glon
	+,kmd,eqmax,eqav,keq,knum,nn
	 rut=iuteq+imm/60.
C
C
Cpre   21 tkp=thpo
   21 tkp=rut
Cpre      itkp=int(tkp-0.005)
       itkp=nint(rut)
	iyear=int(ryear)
	iyr=iyear-iyear/100*100
C
       if (lda.gt.1) GOTO	111
C
C Read last day of prec year:
C
	iyear_pre=iyear-1
	 call blet4(iyear_pre,AYEAR_pre)
	infhpo(17:19)=AYEAR_pre
C	OPEN(15,file=infhpo,action='READ')
         GOTO 41
C
C current year ==============================================
C    Read Hpo
  111    call blet4(iyear,AYEAR)
	infhpo(17:19)=AYEAR
	OPEN(15,file=infhpo,action='READ')
C
C
C++ READ 1h WU,WL,WE
C
	call blet2(iyr,AYR)
	infileu(21:22)=AYR
	infilel(21:22)=AYR
	infiler(21:22)=AYR
	OPEN(11,file=infileu,action='READ')
	read(11,*) txt
      OPEN(12,file=infilel,action='READ')
	read(12,*) txt
      OPEN(13,file=infiler,action='READ')
	read(13,*) txt
C
      lda1=lda+1
	DO kk=1,lda1
C++ move data up to keep for d-1,d0,d+1 days
	 do k=0,23
	wu(k)=wu(k+24)
	wu(k+24)=wu(k+48)
	wl(k)=wl(k+24)
	wl(k+24)=wl(k+48)
	we(k)=we(k+24)
	we(k+24)=we(k+48)
	 enddo
	read(11,33,end=55) kyr,kmn,kdy,(wu(k+48),k=0,23)
	read(12,33,end=56) kyr,kmn,kdy,(wl(k+48),k=0,23)
	read(13,33,end=57) kyr,kmn,kdy,(we(k+48),k=0,23)
	 ENDDO
   55	close(11)
   56	close(12)
   57	close(13)
      nitkp=itkp+24
C WUmax
      wumax=0.
	itwu=0
	n1=nitkp-24 !tkp-24h
	n2=nitkp+24 !tkp+24h
	do k=n1,n2  !new
	if (wu(k).gt.wumax) then
	wumax=wu(k)
	itwu=k-24
	endif
	enddo
	jtwu=itwu-itkp
	twu=itwu-tkp
C WLmin
      wlmin=0.
	itwl=0
	do k=n1,n2
	if (wl(k).lt.wlmin) then
	wlmin=wl(k)
	itwl=k-24
	endif
	enddo
	jtwl=itwl-itkp
	twl=itwl-tkp
C WEmax
      wemax=0.
	itwe=0
	do k=n1,n2
	if (we(k).gt.wemax) then
	wemax=we(k)
	itwe=k-24
	endif
	enddo
	jtwe=itwe-itkp
	twe=itwe-tkp
C
C Output
        if (iev.eq.1) GOTO 123
      IF((abs(wumax-wumax_pre).lt.0.01).and.(abs(wlmin-wlmin_pre)  !++++++++++
	+.lt.0.01)) THEN
	if ((wumax.eq.wu_out).and.(wlmin.eq.wl_out)) GOTO 123
	if (iapo.ge.iapo_pre) then	  !==========
	 if (lda.eq.lda_out) goto 123
      ndy=ndy+1
      write(*,32) ryear,lda,imn,idy,tkp,hpomax,iapo,twu,wumax,twl,wlmin
	+,twe,wemax,ndy
	write(14,32) ryear,lda,imn,idy,tkp,hpomax,iapo,twu,wumax,twl,wlmin
	+,twe,wemax,ndy
	 lda_out=lda
	wu_out=wumax
	wl_out=wlmin
	 goto 123
C	endif
                                                      else       !===========
C
       if (lda_pre.eq.lda_out) goto 123
	if ((wumax_pre.eq.wu_out).and.(wlmin_pre.eq.wl_out)) GOTO 123
      ndy=ndy+1
	write(*,32) ryear_pre,lda_pre,imn_pre,idy_pre,tkp_pre,hpomax_pre
	+,iapo_pre,twu_pre,wumax_pre,twl_pre,wlmin_pre,twe_pre,wemax_pre
     +,ndy
	write(14,32) ryear_pre,lda_pre,imn_pre,idy_pre,tkp_pre,hpomax_pre
	+,iapo_pre,twu_pre,wumax_pre,twl_pre,wlmin_pre,twe_pre,wemax_pre
     +,ndy
	 lda_out=lda_pre
	wu_out=wumax_pre
	wl_out=wlmin_pre
	goto 123													!==============
	                          endif
	                                          ELSE					   !++++++++++
	 if ((wumax.eq.wu_out).and.(wlmin.eq.wl_out)) GOTO 123
      ndy=ndy+1
      write(*,32) ryear,lda,imn,idy,tkp,hpomax,iapo,twu,wumax,twl,wlmin
	+,twe,wemax,ndy
	write(14,32) ryear,lda,imn,idy,tkp,hpomax,iapo,twu,wumax,twl,wlmin
	+,twe,wemax,ndy
	  lda_out=lda
	wu_out=wumax
	wl_out=wlmin
                                       ENDIF								!++++++++++
C
  123    ryear_pre=ryear
	lda_pre=lda
	imn_pre=imn
	idy_pre=idy
	tkp_pre=tkp
	hpomax_pre=hpomax
	twu_pre=twu
	wumax_pre=wumax
	twl_pre=twl
	wlmin_pre=wlmin
	twe_pre=twe
	wemax_pre=wemax
	iapo_pre=iapo
C
   41 continue
C
   32 format(1X,F8.3,1X,I3,2(1X,I2),1X,F4.1,1X,F6.3,1X,I4
     +,3(1X,F5.1,1X,F6.2),1X,I4)
   50	close(unit=14)
	pause ' '
	STOP
	END